#!/bin/sh


VERSION=22
MEDIASERVER=/media/hdd/Mediaserver7025/Mediaserver7025
ERHOME=/usr/lib/enigma2/python/Plugins/Extensions/ER

PROGRAMC=$ERHOME/0_RECORDTIMER/1_RECORD_channel_
PROGRAMBH=$ERHOME/0_RECORDTIMER/1_RECORD_begin_hour_
PROGRAMBM=$ERHOME/0_RECORDTIMER/1_RECORD_begin_minute_
PROGRAMEH=$ERHOME/0_RECORDTIMER/1_RECORD_end_hour_
PROGRAMEM=$ERHOME/0_RECORDTIMER/1_RECORD_end_minute_


TIMERS=$ERHOME/timers.xml
TIMERSORIG=/etc/enigma2/timers.xml
TIMERSTMP=$ERHOME/timers.tmp
RECORD=$ERHOME/record.sh
SERVICEREF=$ERHOME/serviceref.lst
USERBOUQUET=/etc/enigma2/userbouquet.favourites.tv
SHEDULE=$ERHOME/reload_sheduled

rm $TIMERSTMP > /dev/null 2>&1

cp $USERBOUQUET $SERVICEREF
dos2unix $SERVICEREF
sed -ie s!"#SERVICE "!!g $SERVICEREF
sed -ie s!"#NAME Favourites (TV)"!!g $SERVICEREF
sed '/^[ 	]*$/d' < $SERVICEREF > $TIMERSTMP && mv $TIMERSTMP $SERVICEREF
# now we have plain serviceref list !
chmod 777 $SERVICEREF

#
REPEATED="0"
AFTEREVENT="nothing"
DISABLED="0"
JUSTPLAY="0"
# if nothing passed will record 2h
LATER=120
EIT="0"


# processing time
CDATE=`date -u`
CSEC=`date -u +'%s'`
CHOUR=`date -u +'%H'`
CMINUTE=`date -u +'%M'`
CMONTH=`date -u +'%m'`
CMONTHDAY=`date -u +'%d'`
CWEEKDAY=`date -u +'%w'`
#echo "Current time in seconds since 1970: $CSEC"
LSEC=`expr $LATER "*" 60`
#echo "Seconds in the Future $LSEC"
LSEC=`expr $LSEC "+" $CSEC`



# check for Channel 
if  [  ! $1 ]; then
    if [ -f $PROGRAMC* ]; then
       CHANNEL=`cat $PROGRAMC*`
    else
       echo "No Channel passed will use 1!"
       CHANNEL="1"
    fi
else
    CHANNEL=$1
fi
    echo "Channel for recording is $CHANNEL"

# check for begin
if  [  ! $2 ]; then
    if [ -f $PROGRAMC* ]; then
       BEGINH=`cat $PROGRAMBH*`
       BEGINM=`cat $PROGRAMBM*`
       if [ $BEGINH -lt 10 ]; then 
          BEGINH="0$BEGINH"
       fi
       if [ $BEGINM -lt 10 ]; then 
          BEGINM="0$BEGINM"
       fi
       BEGIN="$BEGINH:$BEGINM"
#       echo $BEGIN
       BEGIN=`date -d $BEGIN +'%s'`
    else
       echo "No time passed for beginning recording using current time !"
       BEGIN=$CSEC
    fi
else
    BEGIN=`date -d $2 +'%s'`
fi
echo "Time for beginning of record will be $BEGIN in epoch time"
# check for end
if  [  ! $3 ]; then
    if [ -f $PROGRAMC* ]; then
       ENDH=`cat $PROGRAMEH*`
       ENDM=`cat $PROGRAMEM*`
       if [ $ENDH -lt 10 ]; then 
          ENDH="0$ENDH"
       fi
       if [ $ENDM -lt 10 ]; then 
          ENDM="0$ENDM"
       fi
       END="$ENDH:$ENDM"
#       echo $END
       END=`date -d $END +'%s'`
    else
       echo "No time passed for ending recording using begin time + 2h!"
       LSEC=`expr $LATER "*" 60`
       #echo "Seconds in the Future $LSEC"
       LSEC=`expr $LSEC "+" $BEGIN`
       END=$LSEC
    fi 
else
    END=`date -d $3 +'%s'`
fi
echo "Time for ending of record will be $END in epoch time"
# check for name
if  [  ! $4 ]; then
    NAME="Recording"
else
    NAME=$4
fi
# check for description
if  [  ! $5 ]; then
    DESCRIPTION="planned by shell script"
else
    DESCRIPTION=$5
fi

# getting serrviceref
head -$CHANNEL $SERVICEREF | tail -n 1 - > $TIMERSTMP
SERVICEREF=`cat $TIMERSTMP`
echo "Serviceref is $SERVICEREF"
#
# create new timers.xml
# work locall because I don't have privileges
#
#rm $TIMERS > /dev/null 2>&1
#cp $TIMERSORIG $TIMERS > /dev/null 2>&1

if [ ! -f $TIMERS ]; then
#   echo "$TIMERS doesn't exist, adding header"
   echo '<?xml version="1.0" ?>' > $TIMERS
   echo "<timers>" >> $TIMERS
else
#   echo "$TIMERS exists already, removing header and tail"
   sed -ie s!'<?xml version="1.0" ?>'!!g $TIMERS
   sed -ie s!"<timers>"!!g $TIMERS
   sed -ie s!"</timers>"!!g $TIMERS
   cp $TIMERS $TIMERSTMP
#   cat $TIMERSTMP
   echo '<?xml version="1.0" ?>' > $TIMERS
   echo "<timers>" >> $TIMERS
   cat $TIMERSTMP >> $TIMERS
   rm $TIMERSTMP
fi
echo '<timer begin="'$BEGIN'" end="'$END'" serviceref="'$SERVICEREF'" repeated="'$REPEATED'" name="'$NAME'" description="'$DESCRIPTION'" afterevent="'$AFTEREVENT'" eit="'$EIT'" disabled="'$DISABLED'" justplay="'$JUSTPLAY'">' >> $TIMERS
echo "</timer>"  >> $TIMERS
echo "</timers>"  >> $TIMERS
#cat $TIMERS
# removing empty lines
sed '/^[ 	]*$/d' < $TIMERS > $TIMERSTMP && mv $TIMERSTMP $TIMERS
WHO=`whoami`

if  [ $WHO = "root" ]; then
echo "I'm root hence reloading enigma2 and update timers.xml"
rm $TIMERSORIG > /dev/null 2>&1
ln -sf $TIMERS $TIMERSORIG > /dev/null 2>&1
init 2
init 3
else
echo "Running a dameon only cann't restart enigma or update timers.xml"
echo "will only schedule restart via cron dameon !"
touch $SHEDULE
fi

rm $TIMERSTMP > /dev/null 2>&1

exit 0
